%define anolis_release 2
%bcond_with perl_Test_NoWarnings_enables_stack_trace

Name:           perl-Test-NoWarnings
Version:        1.06
Release:        %{anolis_release}%{?dist}
Summary:        Make sure you didn't emit any warnings while testing
License:        LGPLv2+
URL:            https://metacpan.org/release/Test-NoWarnings
Source0:        https://cpan.metacpan.org/authors/id/H/HA/HAARG/Test-NoWarnings-%{version}.tar.gz
BuildRequires:  coreutils make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter perl(:VERSION) >= 5.6 perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict) perl(warnings) perl(Carp) perl(Exporter) perl(Config)
BuildRequires:  perl(Test::Builder) >= 0.86 perl(Test::More) >= 0.47 perl(Test::Tester) >= 0.107
%if %{with perl_Test_NoWarnings_enables_stack_trace}
BuildRequires:  perl(Devel::StackTrace)
%endif
%if %{with perl_Test_NoWarnings_enables_stack_trace}
Suggests:       perl(Devel::StackTrace)
%endif

BuildArch:      noarch

%description
In general, your tests shouldn't produce warnings. This module causes any
warnings to be captured and stored. It automatically adds an extra test
that will run when your script ends to check that there were no warnings.
If there were any warnings, the test will give a "not ok" and diagnostics of
where, when and what the warning was, including a stack trace of what was
going on when the it occurred.

If some of your tests are supposed to produce warnings then you should
be capturing and checking them with Test::Warn, that way
Test::NoWarnings will not see them and so not complain.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n Test-NoWarnings-%{version}

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL NO_PACKLIST=1 NO_PERLLOCAL=1 INSTALLDIRS=vendor
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*

# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -r -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes README

%changelog
* Tue Apr 11 2023 Kaihao Bai <carlo.bai@linux.alibaba.com> - 1.06-2
- optimize spec

* Thu Feb 02 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.06-1
- init from upstream
